/* BBBasicShapeBallsSticks.h				 
 *
 * This region shape draws a balls&sticks region.
 *
 * Usage: Use it as a simple regionShape..
 *	
 * Written by: 		Thomas Engel
 * Created:    		23.05.1994 (Copyleft)
 * Last modified: 	23.05.1994
 */

#import "BBRegionShape.h"

@interface BBBasicShapeBallsSticks:BBRegionShape

- addSubshapesTo:aList;

- (float)atomRadius:sender;
- (float)bondRadius:sender;
- (NXColor)bondColor:sender;

@end

/*
 * History: 23.05.94 First regionShape subclass..
 *
 *
 * Bugs: - Nop
 */