/* BBDefaultCamera.h				 
 *
 * This is a swapable defaults provider that serves the BBCameraWindow.
 *
 * Usage: Just ask for the defaults data you need.
 *
 * Written by: 		Thomas Engel
 * Created:    		14.05.1994 (Copyleft)
 * Last modified: 	24.05.1994
 */

#import <misckit/MiscSwapContentsController.h>

@interface BBDefaultCamera:MiscSwapContentsController
{
	id	backgroundColor;
	id	printBackgroundSwitch;
}

- revert:sender;
- (BOOL)hasDefaultsFor:anObject;

- (NXColor)backgroundColor;
- (BOOL)doesPrintBackgroundColor;

@end

/*
 * History: 24.05.94 Added support for backgroundColor printing.
 *
 *			14.05.94 First implementation.
 *
 *
 * Bugs: - Not fully implemented yet.
 */