// DifferentiatorInspector.h
// By Charles G. Fleming, Educational Computing Services, Allegheny College.
// Copyright 1993, Allegheny College.
// You may freely copy, distribute and reuse this code. 
// Allegheny College and the author disclaim any warranty of any kind, 
// expressed or implied, as to its fitness for any particular use.

#import <appkit/appkit.h>

#import "ToolAndInspectorProtocols.h"

@interface DifferentiatorInspector:Object <WBToolInspector>
{
    id	window;
	id 	object;

	// Instance variables specific to the particular inspector you are
	// building.
	id	orderTextField;
	id	differentiationVariableTextField;
	id	inputFormButton;
}

- ok:sender;
- revert:sender;
@end
