// AbstractView.h

#import <appkit/appkit.h>

@interface AbstractView:View
{
	id controller;
	id xMinField;
	id xMaxField;
	id yMinField;
	id yMaxField;
	id showLabels;
	float xMin, xMax, yMin, yMax;
}

- initFrame:(const NXRect *)frameRect;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- (BOOL)acceptsFirstResponder;
- copy:sender;
- zoomIn:sender;
- zoomOut:sender;
- newLimits:sender;
- awakeFromNib;
- (void)displayLimits;

@end
