// Eigen.h
// By Charles G. Fleming, Educational Computing Services, Allegheny College.
// Copyright 1993, Allegheny College.
// You may freely copy, distribute and reuse this code. 
// Allegheny College and the author disclaim any warranty of any kind, 
// expressed or implied, as to its fitness for any particular use.

#import <appkit/appkit.h>

#import "ToolAndInspectorProtocols.h"

@interface Eigen:Object <WBTool>
{
	id	inputText;
	id	outputText;
	id	outputViewBox;
	id	inspector;
	id	mathConnector;
	id	improvConnector;

	// Instance variables specific to the particular tool you are building.

}

- init;
- setMathConnector:anObject;
- setImprovConnector:anObject;

// Implement methods that will be called by your inspector's ok: and
// revert methods.
@end
