/* Gaussian.h  	by Paul Kunz	January 1993
 * Subclass of PFunction to manage a Gaussian function
 *
 * Copyright (C)  1993  The Board of Trustees of
 * The Leland Stanford Junior University. All Rights Reserved.
 */

#define GAUSSIAN_H_ID "$Id: Gaussian.h,v 1.2 1993/01/31 20:17:35 pfkeb Exp $"

#import "PFunction.h"

@interface Gaussian : PFunction
{
}

- init;
 /*
  * The designated initialzer.
  */
  
- setInitialValues;
 /*
  * Sets initial values by assuming one gaussian in middle of display.
  */
@end