// TileScrollView.h
// By Jayson Adams, NeXT Developer Support Team
// You may freely copy, distribute and reuse the code in this example.
// NeXT disclaims any warranty of any kind, expressed or implied, as to its
// fitness for any particular use.

#define TILESCROOLVIEW_H "$Id"

#import <appkit/ScrollView.h>


@interface TileScrollView:ScrollView

{
     id		lineMatrix,lineMatrixClipView,stubView;
	 id		colNameMatrix,colNameMatrixClipView;
	 id		Controller;
	 id		arrowMatrix;
	 id		addMatrix;
	 
}

/* instance methods */
- initFrame:(const NXRect *)theFrame;
-makelines:(const NXRect *)theFrame;
-makeColumns:(const NXRect *)theFrame;
-makeArrowMatrix;
-makeAddMatrix;
- free;
- changeScale:sender;
- tile;
- scrollClip:aClipView to:(NXPoint *)aPoint;
-read:(NXTypedStream*)typedStream;
-write:(NXTypedStream*)typedStream;

@end
