/*
 * This structure contains the information for one parameter of the fit
 */
typedef struct _fitParm {
    double              value;
    double              lower_limit;
    double              upper_limit;
    double              error;		// parabolic error
    double              lower_error;	// MINOS lower error
    double              upper_error;	// MINOS upper error
    double              step_size;
    char 		*name;
    BOOL		fixedValue;
    BOOL                fixedLimits;
} fitParm;
