/*
 * hdata.h - prototypes for routines in hdata.c
 *
 * Copyright (C)  1993  The Board of Trustees of The Leland Stanford
 * Junior University.  All Rights Reserved.
 *
 * $Id: hdata.h,v 5.0 1993/08/17 21:54:38 rensing Exp $
 */


#ifndef _HDATA_H_
#define _HDATA_H_


struct maxs 
{
     float xl,xh,yl,yh,zl,zh,xsum,x2sum,ysum,y2sum,xysum;
};
int getXYData( display disp, float **xy, float **xerr, 
	      float **yerr, int **over, struct maxs *m, int *xmin_pt);
int getHistoData( display disp, float **xy, float **xylego, 
		 float **xerr, float **yerr, int **over,struct maxs *m);
int getScatData( display disp, float **xy, struct maxs *m );
int getScatData3D( display disp, float **xyz, struct maxs *m );


#endif
