#import <objc/Object.h>

@interface IcaoController:Object
{
    id  mapWindow;
    id  infoPanel;
		id  prefPanel;
    id  legalPanel;
		id  howManyObjects;
		id  mailSpeaker;
		
		/* PopUp for the PrintPanel */
		id	routeAdjust;
		
		/* Lot's of Cells for automatic enabling */
		id	toolsSubmenuCell;
		id	visibleObjectsCell;
		id	autoRouterCell;
		id	suggestTriangleCell;
		id 	printCell;
}

+ initialize;
- (BOOL)setPort;
- (const char *)user;

- routeAdjust;

- showPreferencesPanel:sender;
- showInfoPanel:sender;
- updateInfoPanel;
- mapChanged:sender;
- showLegalPanel:sender;
- sendComments:sender;

- (BOOL)menuActive:menuCell;
- (BOOL)switchAutorouteMenu:menuCell;

- openMapWindow:sender;
- openMapWindowFromFile:(const char *)filename;
@end

@interface IcaoController(ApplicationDelegate)
- appDidInit:sender;
- appWillTerminate:sender;
@end