#import <objc/Object.h>
#import "IcaoDefinitions.h"
#import <dpsclient/event.h>
#import <appkit/screens.h>

@interface RouteController:Object
{
		id	soaringPanel;
		
    id	triangleBrowser;
		id	takeOffField;
		id	distanceField;
		id	suggestButton;
		id	suggestUnit;
		
		OBJECT	*takeOffObjc;
		
		id	mapController;
		
#ifdef HAVE_TRUE_ROUTEOBJECTS
		/* einige Outlets von und fuer Oliver */
		id tableView;
		id autoWindow;
		id inboundVec;
		id waypointVec;
		id outboundVec;
		id nmVec;
#endif		
		
		struct 
		{
			id	window;
			NXPoint	topLeft;
			NXScreen *theScreen;
		} autoRouteData;
		
}


- setup;

- objectClicked:sender;
- objectDoubleClicked:sender;

- suggest:sender;
- setNewTakeoff:(const char*)takeoff;

- soaringPanel;

- (BOOL)canAutoroute;
- tryToAutoroute:sender;

- takeSuggestUnitFrom:sender;

/* Get notified if Apps terminate */
- appWillTerminate:sender;

@end



@interface RouteController(BrowserDelegate)

- (int)browser:sender getNumRowsInColumn:(int)column;
- browser:sender loadCell:cell atRow:(int)row inColumn:(int)column;

@end


@interface RouteController(WindowDelegate)

- windowWillClose:sender;

@end

#ifdef HAVE_TRUE_ROUTEOBJECTS
@interface RouteController(DBTableDataSources)

- (unsigned int) rowCount;

- getValueFor:identifier at:(unsigned int) aPosition into:aValue;

@end
#endif