/****************************************************************
 *                                                              *
 *                        I C A O   M a p  -                    *
 *                                                              *
 *             A n   A v i a t i o n   U t i l i t y            *
 *                                                              *
 *                                                              *
 *            Copyright (C) 1993, 1994  Martin Pauly            *
 *                                                              *
 *                   N e x t   V e r s i o n                    *
 *                                                              *
 *       Copyright (C) 1994  Stefan Leuker & Oliver Meyer       *
 *                                                              *
 *   This file may be freely distributed only if it includes    *
 *                the above copyright notice.                   *
 *                                                              *
 ****************************************************************/

/* icao -- router module */
#import "IcaoObjects.h"
#import <stdio.h>


/* define max. recursion depth for router */
#define REC_DEPTH  8
#define REC_WIDTH  3


typedef struct {
  int nextpoint;
  OBJECT *waypoints[REC_DEPTH];
  double distance;
} ROUTE;


extern OBJECT		*currentroute[5];


void router_radionav();          /* select radio navigation waypoints */
void next_findroute (char *wholetext, OBJECT *from, OBJECT *via1, OBJECT *via2, 
		       OBJECT *via3, OBJECT *to);


