// DomainAndRange.h
// By Charles G. Fleming, Halchin and Fleming.
// You may freely copy, distribute and reuse this code. 
// Halchin and Fleming, and the author disclaim any warranty of any kind, 
// expressed or implied, as to its fitness for any particular use.

#import <appkit/Window.h>

@interface DomainAndRange:Window
{
    id	domainUpper;
    id	defaults;
    id	domainLower;
    id	rangeLower;
    id	mathGraph;
    id	rangeUpper;
    id  okButton;
    id	parametersWindow;
    double domainLow, domainUp, rangeLow, rangeUp;
}

- initContent:(const NXRect *)contentRect style:(int)aStyle 
      backing:(int)bufferingType buttonMask:(int)mask defer:(BOOL)flag; 
- setValues:sender;
- activate:sender;
- default:sender;
- defaultButton:sender;
- performClick:sender;
-(double)domainLower;
-(double)domainUpper;
-(double)rangeLower;
-(double)rangeUpper;

@end
