// ParameterController.h
// By Charles G. Fleming, Halchin and Fleming.
// You may freely copy, distribute and reuse this code. 
// Halchin and Fleming, and the author disclaim any warranty of any kind, 
// expressed or implied, as to its fitness for any particular use.

#import <appkit/Window.h>

@interface ParameterController:Window
{
    id	frictionField;
    id	forcingFrequencySlider;
    id	massSlider;
    id	forcingFrequencyField;
    id	initialVelocitySlider;
    id	initialVelocityField;
    id	massField;
    id	forcingMagnitudeSlider;
    id	initialPositionSlider;
    id	forcingMagnitudeField;
    id	springConstantSlider;
    id	initialPositionField;
    id	frictionSlider;
    id	springConstantField;
    id	resultScrollView;
    id	mathTool;
    id	mathGraph;
    id 	domainAndRange;
    id  plotButton;
    id	graphSettingsButton;
    char *solution;
    BOOL notCleared;
}

- appDidInit:sender;
- compute:sender;
- plotSolution:sender;
- setValues:sender;

@end
