/*
 * Mandel.h, Jan. 1992
 * by R. Pajarola
 * E-mail: rpajarol@iiic.ethz.ch
 */

#import "MandelView.h"
#import <objc/Object.h>
#import <appkit/Window.h>

@interface Mandel:Object
{
    id infoPanel;
	id helpPanel;
	id savePanel;
	MandelView *myView;
}

- windowWillResize:window toSize:(NXSize *)size;
- displayInfoPanel:sender;
- displayHelpPanel:sender;
- saveRequest:sender;
- saveViewInPath:(const char *)name;

@end
