/* MAConcreteNumber - Concrete subclasses of MANumber
   
    Copyright (C) 1995, Adam Fedor

*/

#ifndef __MAConcreteNumber_INCLUDE_
#define __MAConcreteNumber_INCLUDE_

#include "MathArray/MAValue.h"

@interface MAComplexFloatNumber : MANumber
{
    complex_float data;
}

- initValue:(const void *)value withObjCType:(const char *)type;
@end

@interface MAComplexDoubleNumber : MANumber
{
    complex_double data;
}

- initValue:(const void *)value withObjCType:(const char *)type;
@end

#endif
