/*
    MathTemplateArray - Template for several number array classes
    
    Copyright (C) 1995, Adam Fedor
    
    This header file is not actually used, but it gives an idea of what methods
    a subclass of MathArray should respond to.
        
    $Id: MathTemplateArray.h,v 1.4 1995/05/03 16:48:04 adam Exp $
*/

#import "MathArray.h"

@interface MathTemplateArray : MathArray
{
    // Don't, I say, don't define any instance variables in subclasses
    // of MathArray! ok!
}

+ (unsigned long)precision;
+ (const char *)objCType;

- convertFromObjCType:(const char *)type;

- maAbs;
- maInvert;
- (id <NSNumber,ComplexNumber>)maMinimumValue;
- (id <NSNumber,ComplexNumber>)maMaximumValue;
- (id <NSNumber,ComplexNumber>)maTotal;
- maWhere;

@end
