/* MolShape.h - Copyright 1993 Steve Ludtke */
#import <3Dkit/3Dkit.h>

@interface MolShape : N3DShape
{
int mode,flags;					/* display mode and flags */
float BSR,BSS;
float mmx[2],mmy[2],mmz[2];		/* min/max x,y,z */
float theta,chi,phi;			/* molecule orientation */
Molecule *mol;					/* pointer to molecule (passed from MolObj) */
int nmol;						/* # molecules, currently always 1 or 0 */
struct ELINFO *elinfo;			/* element info struct for colors/sizes */
}
- renderSelf:(RtToken)context;
- setData:(Molecule *)Mol :(int)Nmol :(struct ELINFO *)Elinfo :(int)Mode :(int)Flags;
- setSurfaceType:(N3DSurfaceType)st andDescendants:(BOOL)flag;
- setAng:(float)Theta :(float)Chi :(float)Phi;
-setBSSR:(float)bss :(float)bsr;

@end
