INSTALLDIR=	/LocalApps/TotalChaos.app

DYNAVIEWS =	Lorenz.Chaoso

all: $(DYNAVIEWS)

THINGSTOINSTALL = $(DYNAVIEWS) Lorenz.nib

.SUFFIXES: .m .Chaoso .c .psw .o

.psw.h:
	pswrap -a -h $*.h -o $*.c $*.psw
.psw.o:
	pswrap -a -h $*.h -o $*.c $*.psw
	cc -O -g -Wall -c $*.c -o $*.o

#.o.Chaoso:  why doesn't this work?
Lorenz.Chaoso:Lorenz.o
	ld -x -r -o $@ $*.o

.m.o:
	cc -O -g -Wall -c $*.m -o $*.o

#all::
#	$(MAKE) $(PSWFILES)
#	$(DYNAVIEWS)
	
clean::
	rm -rf $(PSWFILES) $(DYNAVIEWS) $(THINGSTOREMOVE)
	

install::	all install-views

install-views::
	mkdirs $(INSTALLDIR) && \
	for view in $(THINGSTOINSTALL); do \
	  cp $$view $(INSTALLDIR); \
	done
