// AcceptDragScrollView.h
// By Charles G. Fleming, Educational Computing Services, Allegheny College.
// Copyright 1993, Allegheny College.
// You may freely copy, distribute and reuse this code. 
// Allegheny College and the author disclaim any warranty of any kind, 
// expressed or implied, as to its fitness for any particular use.

#import <appkit/appkit.h>

@interface AcceptDragScrollView:ScrollView
{
	id	blackBorderNXImage;
	id	toolLoader;
	id	dragPasteboard;
	NXDragOperation dragOperation;
}

- setToolLoader:anObject;

// Dragging methods.
- (NXDragOperation)draggingEntered:sender;
- (NXDragOperation)draggingUpdated:sender;
- draggingExited:sender;
- (BOOL)prepareForDragOperation:sender;
- (BOOL)performDragOperation:sender;
- concludeDragOperation:sender;
@end
