// use the syntax xjy to represent a complex number

#include <complex.h>

complex::complex(){
    re=0; im=0;
    }

complex expj( double w ){
    return complex( cos(w), sin(w) );
}

ostream& operator<<(ostream& s, complex a) {
    if( imag(a) == 0)
        return s<<real(a);
    else if( real(a) == 0)
	return s<<"j"<<imag(a);
    else
	return s<<real(a)<<"j"<<imag(a);
}

istream& operator>>(istream& s, complex& a) {
// #, #j # and j # are acceptable
// want #, #j#, j#, #j, j, #+j#, #-j#, #+#j, #-#j to be acceptable. LATER!!
    double re = 0, im = 0;
    char c = 0;

    s>>c;
    if (c == 'j') {
	im=1;
	s.unsetf( ios::skipws );
	s>>im;
	}
    else {
	s.putback(c);
	s>>re;
	s.get(c);
	if (c == 'j') {
	    s.unsetf( ios::skipws );
	    s>>im;
	    }
	else
	    s.putback(c);
	}

    s.setf( ios::skipws );
    if (s) a = complex(re,im);
    return s;
    }
