#include "stats.h"
#include "math.h"

void stats::operator+=( double x ) {
    n++;
    sum += x;
    sum2 += x*x;
    if( (x=abs(x)) > max_abs ) 
	max_abs = x;
}

ostream& operator<<( ostream& s, const stats& st ) {
    double mean=st.sum/st.n;
    s << "mean= "<< mean << endl;
    /* a zero-bias estimator of the std. deviation */
    s << "standard deviation= "<< sqrt((st.sum2 - mean*st.sum)/(st.n-1)) << endl;
    s << "maximum absolute value= "<< st.max_abs << endl;
    return s;
}
