#include <libc.h>
#include <fstream.h>
#include "filter.h"

/*
 * Find the 1-norm of a signal given its Z-transform
 */

main(int argc, char *argv[]){
    if( argc != 2 ){
	cerr << "File containing Z-transform needed.\n";
	exit(-1);
	}

    ratfn H;
    if( !H.read_in( argv[1] ) ) exit(-1);
    cout << H.h1() << '\n';
    }
