int kfrom(int i,int j,int n);
float ClosestCities(float *Distance, int *From, int *To, int NumberOfCities);
float FarthestCities(float *Distance, int *From, int *To, int NumberOfCities);
void CalculateDistance(float *data, float *Distance, int NumberOfCities);
int ValidTour(int *Tour, int Edge1, int Edge2, int Reverse, int NumberOfCities);


#ifdef MYDIR
float CheapestInsertion(float *Distance, int *tour, int NumberOfCities);
float NearestNeighbor(float *Distance, int *tour, int NumberOfCities);
float NearestAddition(float *Distance, int *tour, int NumberOfCities);
float FarthestInsertion(float *Distance, int *tour, int NumberOfCities);
float TourOptimization(float *Distance, int *tour, float OptimalValue, 
                       int NumberOfCities);
#else
float CheapestInsertion(TwoDView *self, float *data, float *Distance, 
      int *Tour, int NumberOfCities);
float NearestNeighbor(TwoDView *self, float *data, float *Distance, 
      int *Tour, int NumberOfCities);
float NearestAddition(TwoDView *self, float *data, float *Distance, 
      int *Tour, int NumberOfCities);
float FarthestInsertion(TwoDView *self, float *data, float *Distance, 
      int *Tour, int NumberOfCities);
float TourOptimization(TwoDView *self, float *data, float *Distance, 
      int *Tour, float OptimalValue, int NumberOfCities);
#endif


