/* BBAtomLibraryBrowserController.h				 
 *
 * This subclass of MiscSwapContentsCtrl is in charge of the browser section
 * of the atomlibrary
 *
 * Usage: just see the NIB and code. Not very reusable anyway.
 *		  We simply control a one column browser that allows one selection.
 *
 * Written by: 		Thomas Engel
 * Created:    		12.01.1994 (Copyleft)
 * Last modified: 	14.05.1994
 */

#import <misckit/MiscSwapContentsController.h>

@interface BBAtomLibraryBrowserController:MiscSwapContentsController
{
	id	browser;
	id	atomList;
}

- revert:sender;

- selectNewAtom:sender;

// To handle the browser..we are his delegate

- (int)browser:sender fillMatrix:matrix inColumn:(int)column;
- browser:sender loadCell:cell atRow:(int)row inColumn:(int)column;

@end

/*
 * History: 14.05.94 Switched to new name: BB...
 *
 *			10.02.94 MiscSwap compatible now.
 *
 *			12.01.94 First implementation.
 *
 *
 * Bugs: - Not a bug but switching the sorting type does nothing right now.
 *		   The find Objc related to cell will reflect these settings.
 */