/* BBBackgroundShape.h				 
 *
 * Renders a sphere that will serve as our background color..
 *
 * Usage: ...
 *
 * Written by: 		Thomas Engel
 * Created:    		24.05.1994 (Copyleft)
 * Last modified: 	24.05.1994
 */

#import <appkit/appkit.h>
#import <3Dkit/3Dkit.h>

@interface BBBackgroundShape:N3DShape
{
	RtColor		backgroundColor;
	N3DShader *	ourShader;
}

- renderSelf:(RtToken)context;
- setBackgroundColor:(NXColor)aColor;

@end

/*
 * History: 24.05.94 Written to fix NeXTs background bug.
 *
 *
 * Bugs: - Nop
 */