/* BBBioRegion.h				 
 *
 * A class that can be used to handle biological regions. It provides some
 * extra methods for working with them. This region is used by some special
 * shapes.
 *
 * Usage: Same as for the simple region.
 *
 * Written by: 		Thomas Engel
 * Created:    		23.05.1994 (Copyleft)
 * Last modified: 	23.05.1994
 */

#import "BBRegion.h"

@interface BBBioRegion:BBRegion

// Returns a list of atoms that are the cBackbonde of this region.

- cBackbone;

@end

/*
 * History: 23.05.94  First creation.
 *
 *
 * Bugs: - Yes.
 */
