/* BBBrowserManager.h				 
 *
 * This is my subclass of the IKSuitcase to allow browsing suitcases like
 * the folder objects.
 *
 * Usage: Use it like an IKsuitcase with some additions from the IKFolder.
 *
 * Written by: 		Thomas Engel
 * Created:    		14.05.1994 (Copyleft)
 * Last modified: 	16.05.1994
 */

#import <iconkit/iconkit.h>

@interface BBBrowserManager:IKBrowserManager
{
	id	shelf;
	id	selectionList;
}

- initBrowser:aBrowser root:anObject;
- free;

- browser:sender setColumnIcon:cell for:(int)column;
- updateSelection:sender;
- openSelection:sender;
- group:sender;

// These are methods we implement as the windows delegate.

- windowWillClose:sender;
- windowDidClose:sender;
- windowDidBecomeMain:sender;
- windowDidResignMain:sender;

@end

/*
 * History: 16.05.94 Now we do control the window and browsing stuff.
 *
 *
 * Bugs: - Nop..:-)
 */
