/* BBRegionAttributesController.h				 
 *
 * This subclass of MiscInspector is in charge of a regions attribute
 * settings.
 *
 * Usage: Just see the NIB and code. Not very reusable anyway.
 *		  We control name.
 *
 * Written by: 		Thomas Engel
 * Created:    		21.01.1994 (Copyleft)
 * Last modified: 	23.05.1994
 */

#import <misckit/MiscInspector.h>

@interface BBRegionAttributesController:MiscInspector
{
	id	nameField;
	id	typeField;
	id	styleField;
	id	shapeMatrix;
}

- textDidChange:sender;
- styleDidChange:sender;
- ok:sender;
- revert:sender;

@end

/*
 * History: 23.05.95 Supports the new style selection mode.
 *
 *			12.05.94 Converted to fit BB... naming
 *
 *			09.03.94 Made it a Region inspector.
 *
 *			24.02.94 Changed for new swapKit.
 *
 *			21.01.94 First implementation.
 *
 *
 * Bugs: - not very likely.
 */