// EigenInspector.m
// By Charles G. Fleming, Educational Computing Services, Allegheny College.
// Copyright 1993, Allegheny College.
// You may freely copy, distribute and reuse this code. 
// Allegheny College and the author disclaim any warranty of any kind, 
// expressed or implied, as to its fitness for any particular use.

#import "EigenInspector.h"
#import "Eigen.h"

@implementation EigenInspector

// ****************************************************************************
// ****************************************************************************
// Inspector protocol methods.
// ****************************************************************************
// ****************************************************************************

// Return the title for the inspector's panel.
- (char *)inspectorTitle
{
	return "Eigen Inspector";
}

// Return the window that represents the inspector.
- window
{
	return window;
} 

// Make sure the inspector displays the object's current values.
- revert:sender
{
	return self;
}

// Set the object's current values.
- ok:sender
{

	// Make the inspector's window be the first responder so that 
	// textDidChange: messages will be received.
	[window makeFirstResponder:window];
	return self;
}

@end
