/* gvDraw2.m	by Paul Kunz	July 1992
 * This file contains methods implemented in NeXTSTEP 2.0 version
 * of GraphicView which were removed from the 3.0 version.   These
 * methods are needed by HippoDraw
 */

#import "draw.h"

const char gvDraw2_m_rcsid[] = "$Id: gvDraw2.m,v 1.3 1993/06/30 22:47:43 rensing Exp $";

@implementation GraphicView(Draw2)

- graphicsPerform:(SEL)aSelector andDraw:(BOOL)flag
{
    if (flag) {
        [self graphicsPerform:aSelector];
    } else {
        [slist makeObjectsPerform:aSelector];
    }
    
    [self dirty];
    return self;
}

- graphicsPerform:(SEL)aSelector with:(void *)argument andDraw:(BOOL)flag
{
    if ( flag ) {
        [self graphicsPerform:aSelector with:argument];
    } else {
	[slist makeObjectsPerform:aSelector with:argument];
    }

    [self dirty];
    return self;
}
@end
