      INTEGER MNE,MNI,MAXDBG,MAXSTK,MNIHL
      PARAMETER (MNE=100,MNI=50,MAXDBG=10,MAXSTK=10)
      PARAMETER (MNIHL=MNI*(MNI+1)/2)
 
      COMMON
     1/MN7NAM/ CPNAM(MNE)
      CHARACTER*10 CPNAM
C  CPNAM   Parameter name (10 characters)
      COMMON
     2/MN7EXT/ U(MNE),ALIM(MNE),BLIM(MNE)
      REAL*8   U,     ALIM,     BLIM
 
C  U       External (visible to user in FCN) value of parameter
C  ALIM, BLIM Lower and upper parameter limits. If both zero, no limits.
 
      COMMON
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)
      REAL*8   GRD        ,G2         ,GSTEP      ,GIN      ,DGRD
 
      COMMON
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)
      INTEGER  NVARL      ,NIOFEX     ,NEXOFI
 
C  NVARL   =-1 if parameter undefined,      =0 if constant,
C          = 1 if variable without limits,  =4 if variable with limits
C   (Note that if parameter has been fixed, NVARL=1 or =4, and NIOFEX=0)
C  NIOFEX  Internal parameter number, or zero if not currently variable
C  NEXOFI  External parameter number for currently variable parameters
 
      COMMON
     D/MN7NPR/ MAXINT ,NPAR   ,MAXEXT ,NU
      INTEGER  MAXINT ,NPAR   ,MAXEXT ,NU
 
      COMMON
     E/MN7IOU/ ISYSRD ,ISYSWR ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG
      INTEGER  ISYSRD ,ISYSWR ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG
 
      COMMON
     E/MN7IO2/ ISTKRD(MAXSTK) ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR
      INTEGER  ISTKRD         ,NSTKRD ,ISTKWR         ,NSTKWR,ISYSTR
      EQUIVALENCE (ISTKWR(2),ISYSTR)
 
      COMMON
     F/MN7TIT/ CFROM  ,CSTATU ,CTITL  ,CWORD  ,CUNDEF ,CVRSN ,COVMES
      CHARACTER*50 CTITL
      CHARACTER*10 CWORD,CUNDEF,CSTATU
      CHARACTER*8  CFROM
      CHARACTER*6  CVRSN
      CHARACTER*22 COVMES
 
      COMMON
     G/MN7FLG/ ISW(7) ,IDBG(0:MAXDBG) ,NBLOCK ,ICOMND
      INTEGER  ISW    ,IDBG           ,NBLOCK ,ICOMND
 
      COMMON
     H/MN7MIN/ AMIN   ,UP     ,EDM    ,FVAL3  ,EPSI   ,APSI  ,DCOVAR
      REAL*8   AMIN   ,UP     ,EDM    ,FVAL3  ,EPSI   ,APSI  ,DCOVAR
 
      COMMON
     I/MN7CNV/ NFCN   ,NFCNMX ,NFCNLC ,NFCNFR ,ITAUR,ISTRAT,NWRMES(2)
      INTEGER  NFCN,   NFCNMX ,NFCNLC ,NFCNFR ,ITAUR,ISTRAT,NWRMES
 
      COMMON
     J/MN7ARG/ WORD7(7)
      REAL*8   WORD7
 
      COMMON
     K/MN7LOG/ LWARN  ,LREPOR ,LIMSET ,LNOLIM ,LNEWMN ,LPHEAD
      LOGICAL  LWARN  ,LREPOR ,LIMSET ,LNOLIM ,LNEWMN ,LPHEAD
 
      COMMON
     L/MN7CNS/ EPSMAC ,EPSMA2 ,VLIMLO ,VLIMHI ,UNDEFI ,BIGEDM,UPDFLT
      REAL*8   EPSMAC ,EPSMA2 ,VLIMLO ,VLIMHI ,UNDEFI ,BIGEDM,UPDFLT
 
* MINUIT internal parameter blocks follow. The minimization routines
* work in internal coordinates (XINT). Prior to calling FCN,
* internal->external coordinate transformation must be done by calling
* MNINEX(XINT).
 
      COMMON
     3/MN7ERR/ ERP(MNI)   ,ERN(MNI)   ,WERR(MNI)  ,GLOBCC(MNI)
      REAL*8   ERP        ,ERN        ,WERR       ,GLOBCC
 
C  ERP,ERN Positive and negative MINOS errors, if calculated.
C  WERR    Parameter error (standard deviation, defined by UP)
C  GLOBCC  global correlation coefficient
 
      COMMON
     5/MN7INT/ XINT(MNI)  ,XTINT(MNI)    ,DIRIN(MNI)
      REAL*8   XINT       ,XTINT         ,DIRIN
 
      COMMON
     A/MN7VAR/ VHMAT(MNIHL)
      REAL*8   VHMAT
 
      COMMON
     B/MN7VAT/ VTHMAT(MNIHL)
      REAL*8   VTHMAT
