// By Judy D. Halchin, Educational Computing Services, Allegheny College.
// You may freely copy, distribute and reuse this code. 
// Allegheny College and the author disclaim any warranty of any kind, 
// expressed or implied, as to its fitness for any particular use.
// This work was partially supported by a Teacher Preparation grant from the 
// National Science Foundation.


#import <objc/Object.h>

@interface DataCounter:Object
{
}

- (float *)countFrequenciesForData:(int *)data
				count:(int)count
				min:(int *)dataMin
				max:(int *)dataMax
				minMaxProvided:(BOOL)minMaxProvided;

- (float *)countFrequenciesForData:(float *)data 
				count:(int)count 
				numGroups:(int)numGroups 
				mins:(float *)mins 
				maxs:(float *)maxs;
				
- (float *)countFrequenciesForData:(float *)data 	
				count:(int)count 
				numIntervals:(int)numIntervals 	
				boundaries:(float *)boundaries;
				   
- findNumIntervals:(int *)numIntervals 
				boundaries:(float **)boundaries
				forData:(float *)data 
				count:(int)count 
				intervalWidth:(float)intervalWidth;
				
- (float)round:(float)number to:(float)accuracy;

@end
