
#import <appkit/appkit.h>

#import "ToolAndInspectorProtocols.h"

@interface Histogram:Object <WBTool>
{
	id  inputText;
	id	outputText;
	id  outputViewBox;
	id	improvConnector;
	id	inspector;
	id  dataCounter;
	id  histogramView;
	
	float intervalWidth;
	int accuracy;
	char *verticalAxisLabel, *horizontalAxisLabel;
}

- init;


- (float)intervalWidth;
- (int)accuracy;
- (char *)horizontalAxisLabel;
- (char *)verticalAxisLabel;

- setIntervalWidth:(float)width;
- setAccuracy:(int)numDecPlaces;
- setHorizontalAxisLabel:(const char *)label;
- setVerticalAxisLabel:(const char *)label;

@end
