// AreaRule.h --

#import <appkit/View.h>

#define Ncolors 3
#define C_XW 30
#define C_YH 30
#define P_XW (C_XW)
#define P_YH (C_YH)

//#define WIDTH  C_XW
//#define HEIGHT C_YH

#define NsineTable 256
short redTable[NsineTable];
short greenTable[NsineTable];
short blueTable[NsineTable];
void initTable(int phase, int dir);
void intiTimedEntry(float frameRate);

typedef struct
{	unsigned red	:4;
	unsigned green	:4;
	unsigned blue	:4;
	unsigned alpha	:4;
} colorStationPixel;
typedef int cell_image[C_YH+2][C_XW+2];
			// (+2 for wraparound)
typedef colorStationPixel screen_image[P_YH][P_XW];

@interface AreaRule:View
{	screen_image *to_screen;
	id bitmap;
	int c_xw, c_yh;
	screen_image image;
}
id Self;

- start :sender;
- Randomize :sender;
- stop :sender;

- (void)compute;

@end
