#import "IcaoDefinitions.h"
#import <appkit/View.h>

@interface Map:View
{
	int					Elapsed;
	
	//  interna for map projection
	id					bufferImage;
	struct
	{
		BOOL				needsUpdate;
		LOCATION		theOrigin;
		long				scale;
		long				zeroMeridian;
		char				projection;
		NXSize			mapSize;
	} bufferData;

@private
	/* Stores the Data while printing */
	NXRect 				oldFrame;
	
}

/* Converting Coordinates */
- (float)heightCmFrom:(float)mapHeight;
- (float)widthCmFrom:(float)mapWidth;

- bufferNeedsUpdate;
- (BOOL)bufferIsUptodate;
- drawSelf:(const NXRect *)rects :(int)rectCount;

@end

@interface Map(Printing)

- openSpoolFile:(char *)filename;
- endPSOutput;

@end
