#import <appkit/graphics.h>
#import "Map.h"

@interface RouteMap:Map
{
	id	takeOff;
	id	via1;
	id	via2;
	id	via3;
	id	destination;			
	
	/* if YES the Route will be displayed. */
	BOOL	showsRoute;
	
	char	oldOrientation;
	
	BOOL	drawInternalRoute;
}

- initFrame:(const NXRect *)frameRect;
- drawRoute;
- fillGlobalRoute;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- setDrawInternalRoute:(BOOL)flag;
- takeShowsRouteFrom:sender;
- setShowsRoute:(BOOL)flag;
- (BOOL)showsRoute;
- makeRouteFit:(BOOL)forPrinting;

@end
