/* AminoView.h - Copyright 1993  Steve Ludtke */
/* Currently this object just displays a helical wheel diagram */
/* and protein molecular weights. Will be expanded soon ... */

#import <appkit/appkit.h>

@interface AminoView:View
{
	id seqStr;		/* pointer to sequence display */
	id seqlD;		/* sequence length display */
	id seqmwD;		/* molecular weight display */
	id molobj;
	int seqmw;		/* molecular weight */
   	char seq[MAXSEQ+1];	/* 1 letter sequence */
	int seqa[MAXSEQ+1],seql;	/* acid[] # sequece */
	char fCir,fAmb,fPho;	/* flags */
	float AR;	/* angle/residue */
}

- initFrame:(NXRect *)myrect;
- setSequence:sender;				/* sets sequence from string object */
- setSeqStr:sender :(char *)str;	/* sets sequence from passed string */
- superviewSizeChanged:(const NXSize *)oldsize;
- drawSelf:(NXRect *)rects :(int)rectCount;
- dumpEPS:sender;			/* save wheel diagram as eps */
- setCircles:sender;		/* set flags */
- setAmbiv:sender;
- setPhobicOut:sender;
- setAR:sender;
- makeOne:sender;
@end
