/* SelectView.h - Copyright 1993 Steve Ludtke */
#import <appkit/appkit.h>

@interface SelectView:View
{
id notify;				/* object to notify when item(s) (de)selected */
struct SELDAT *data;	/* data to display + select array */
int ndat,nsel;			/* number in data array, number currently selected */
char title[MAXTEXT];	/* title line of display*/
char gtitle[MAXTEXT];	/* symbol title superimposed on title */
}

-setData:(int)n :(struct SELDAT *)Data :Notify;	/* pass data and setup */
-select:(int)n;					/* select line # n */
-selectAll:sender;				/* select all lines */
-deselect:(int)n;				/* deselect line # n */
-deselectAll;					/* deselect all lines */
-mouseDown:(NXEvent *)oevent; 	
-drawSelf:(const NXRect *)rects :(int)nr;
-setHeader:(char *)Title;		/* set title line */
-setGHeader:(char *)Title;		/* set symbol title line */
-notifyO;
-selectAry:(short)n :(short *)sel; /* select array */
-(BOOL)acceptsFirstMouse;	
@end
