// Copyright (95) by melonSoft Ralf Suckow Berlin, All Rights Reserved
//
// You may freely copy, distribute, and reuse the code in this example.
// Ralf Suckow disclaims any warranty of any kind, expressed or  
// implied, as to its fitness for any particular use.

#import <appkit/appkit.h>

@interface PlayerControl:Object
{
    id   browser;
    id   newText;
    id   text;
    id   sounds;
    id   currentSound;
    id   askingFor;
    id   previousAsked;
    id   recordButton;
    id   playButton;
    id   rightPanel;
    id   rightText; 
}

- appDidInit:sender;

- next:sender;
- same:sender;
- help:sender;
- closeHelp:sender;
- ready:sender;

- add:sender;
- remove:sender;
- browserClicked:sender;

- play:sender;
- stop:sender;
- record:sender;
- playSound:sound;
- didRecord:sender;
- hadError:sender;

- save:sender;

- playSoundNamed:(const char *)name;

- (int)browser:sender getNumRowsInColumn:(int)column;
- browser:sender loadCell:cell atRow:(int)row inColumn:(int)column;

@end
