//
// DieRoller
//
// Copyright (C) 1992 Contemporary Design Studios. All rights reserved.
//


#import "Random.h"


@interface DieRoller : Random


{
}


- (int)rollDie:(int)numSides;		// Return a random integer 1 <= x <= numSides.
- (int)roll:(int)numRolls		// Return the best numWanted of numRolls rolls.
  die:(int)numSides;
- (int)rollBest:(int)numWanted		// Return integer sum of best numWanted rolls.
  of:(int)numRolls
  die:(int)numSides;


@end


//
// End of file.
//