#ifdef APOLLO
#include <libc.h>
#endif
#ifdef SUN
#include "SUN_libc.h"
#endif
#include "filter.h"
#include <string.h>
#include <stdlib.h>
#include "Macros.h"

main(int argc, char** argv)
{
    ratfn h;
    transform_variable z;
    char* help_str;
    // read in a tf, h, and simulate it in the time domain.

    if (argc > 2) {
        cerr << "Too many arguments\n";
        cerr << "Usage: demofilter [-h]\n";
        exit(0);
    }
    if (argc == 2) {
        if (!strcmp(argv[1],"-h")) {
            help_str = new (char*)[64];
            if (!help_str) {
                help_str = (char*)malloc(64);
            }
            strcpy(help_str,HELP_CMD);
            strcat(help_str," ");
            strcat(help_str,HELP_PATH);
            strcat(help_str,"filter");
            system(help_str);
            delete help_str;
        }
        else {
            cerr << "Usage: demovector [-h]\n";
            exit(0);
        }
    }

    cin >> h;
    cerr << "h:\n"<< h << endl;

    cerr << "\nAnd now for the time response:\n";
    filter T(h);
    cerr << "After filter construnction, h=\n"<< h << endl;
    double input;
    while(cin >> input) {
	// cerr << endl << T;
	cerr << input << "\t" << T(input) << endl;
    }
}
