#ifdef APOLLO
#include <libc.h>
#endif
#ifdef SUN
#include "SUN_libc.h"
#endif
#include "matrix.h"
#include "Macros.h"
#include <string.h>
#include <stdlib.h>

main(int argc, char** argv)
{
   int i,j;
//   matrix A(3,4);
   char*  help_str;

   if (argc > 2) {
       cerr << "Too many arguments\n";
       cerr << "Usage: demomatrix [-h]\n";
       exit(0);
   }
   if (argc == 2) {
       if (!strcmp(argv[1],"-h")) {
           help_str = new (char *)[64];
           if (!help_str) {
               help_str = (char *)malloc(64);
           }
           strcpy(help_str,HELP_CMD);
           strcat(help_str," ");
           strcat(help_str,HELP_PATH);
           strcat(help_str,"matrix");
           system(help_str);
           delete help_str;
       }
       else {
           cerr << "Usage: demomatrix [-h]\n";
           exit(0);
       }
   }
   cerr << "Number of rows in the matrix :\n";
   cin >> i;
   cerr << "Number of columns in the matrix :\n";
   cin >> j;
   matrix A(i,j);
   // Now initialise the elements
   for (int k=0; k<i; k++) {
        for (int l=0; l<j; l++) {
             A(k,l) = k+l;
             cerr << "A(k,l)=" << A(k,l) << endl;
        }
   }
   cerr << "Matrix A is:\n" << A << endl;
   matrix B = A+A;
   cerr << "Matrix B is:\n" << B << endl;
   matrix C = transpose(A);
   cerr << "Matrix C is:\n" << C << endl;
   matrix D = A/2;
   cerr << "Matrix D is:\n" << D << endl;
}
