#ifdef APOLLO
#include <libc.h>
#endif
#ifdef SUN
#include "SUN_libc.h"
#endif
#include "Macros.h"
#include "stats.h"
#include <string.h>
#include <stdlib.h>

main(int argc, char** argv)
{
    stats st;
    char* help_str;

    /* mean = 4.5, std_dev = 9.16667, max = 9 */
    if (argc > 2) {
        cerr << "Too many arguments\n";
        cerr << "Usage: demostats [-h]\n";
        exit(0);
    }
    if (argc == 2) {
        if (!strcmp(argv[1],"-h")) {
            help_str = new (char*)[64];
            if (!help_str) {
                help_str = (char *)malloc(64);
            }
            strcpy(help_str,HELP_CMD);
            strcat(help_str," ");
            strcat(help_str,HELP_PATH);
            strcat(help_str,"stats");
            system(help_str);
            delete help_str;
        }
        else {
            cerr << "Usage: demostats [-h]\n";
            exit(0);
        }
    }
    for (int i=0; i<10; ++i)
         st += i;
    cerr << st;
    exit(0);
}
