#include <libc.h>
#include <fstream.h>
#include "CofR.h"

/*
 * Realize a modulator with the cascade-of-resonators structure.
 */

char *cmdName;

main(int argc, char *argv[]){
    if( argc != 2 ){
        cerr << "File containing NTF needed.\n";
        exit(-1);
        }
    ratfn H;
    if( !H.read_in( argv[1] ) ) exit(-1);

    CofR realization(H);
    cout << realization;
    }
