/* ******************************************************************** */
/* *                           GCK                                    * */
/* *               A Circuit Simulation Program                       * */
/* *                    by Tanju Cataltepe                            * */
/* *                    (c) Copyright 1989                            * */
/* ******************************************************************** */
/* (c) Copyright 1989, Tanju Cataltepe */

#ifdef GLOBAL

#ifdef Macintosh
long 				object_stamp;
#else
time_t 				object_stamp;
#endif

boolean				up_to_date;
boolean				cmdline_symbols;
boolean				sample_card_found;
timingManager 		timing;
long 				flag_dialog;
long 				flag_compiler;
rcard_struct 		rcard;
rfile_struct 		rfile;
aWord 				sd[MAX_SUBCKT_DEPTH];
double 				**M;
double				**N;
double 				**B;
nodeManager  	 	nodeNames;
symbolManager 		symbolNames;
symbolManager 		commandNames;
long 				ID_nindex_size;
long 				*ID_nindex;
symbol_value 		deltaT_sv;
double 				deltaT;
long				samplesOn;
symbol_value 		periodT_sv;
double 				periodT;
double 				The_Time;
boolean				terminate_on_eof;
boolean				terminate;
symbol_value 		lastTime_sv;
double 				lastTime;
long 				fastTick;
long 				presentTick;
clockRec 			*sampleTicks;
boolean 			TicksRegistered;
long 				NoOfTicks;
long 				NoOfVars;
systemRec 			*baseOfSystem;
branchRec 			*baseOfBranch;
clockRec 			*baseOfClock;
nodeRec 			*baseOfNode;
nonlinRec 			*baseOfNonlin;
digitalRec 			*baseOfDigital;
logicRec 			*baseOfLogic;
tableRec 			*baseOfTable;
modelRec 			*baseOfModel;
sourceRec 			*baseOfSource;
printRec 			*baseOfPrint;
FILE 				*print_file;
fftRec				*baseOfFFT;
fftMRec				*baseOfMFFT;
statusRec 			*baseOfStatus;
subcktRec 			*baseOfSubckt;
double 				*vv_x;
double 				*vv_s;
double				*GND;
long 				twoTerminal;
long 				fourTerminal;
long				nonlinears;
long 				globalControl;
long 				digitals;
long 				logicals;
systemRec 			*presentSys;
boolean				fft_to_file;
aWord				fft_filename;
boolean				fft_must_reorder;
int					fft_window;
boolean				print_to_file;
aWord				prn_filename;
boolean 			shortPrint;
boolean 			timePrint;
boolean 			runDiag;
long 				binaryArray[BINARY_LEN + 1];
nameString 			progName;

#else
/*External Variables*/

#ifdef Macintosh
extern long 			object_stamp;
#else
extern time_t 			object_stamp;
#endif

extern boolean 			up_to_date;
extern boolean			cmdline_symbols;
extern boolean			sample_card_found;
extern timingManager	timing;
extern long 			flag_dialog;
extern long 			flag_compiler;
extern rcard_struct 	rcard;
extern rfile_struct 	rfile;
extern aWord 			sd[MAX_SUBCKT_DEPTH];
extern double 			**M;
extern double 			**N;
extern double 			**B;
extern nodeManager   	nodeNames;
extern symbolManager 	symbolNames;
extern symbolManager 	commandNames;
extern long 			ID_nindex_size;
extern long 			*ID_nindex;
extern symbol_value 	deltaT_sv;
extern double 			deltaT;
extern long				samplesOn;
extern symbol_value 	periodT_sv;
extern double 			periodT;
extern double 			The_Time;
extern boolean			terminate_on_eof;
extern boolean			terminate;
extern symbol_value 	lastTime_sv;
extern double 			lastTime;
extern long 			fastTick;
extern long 			presentTick;
extern clockRec 		*sampleTicks;
extern boolean 			TicksRegistered;
extern long 			NoOfTicks;
extern long 			NoOfVars;
extern systemRec 		*baseOfSystem;
extern branchRec 		*baseOfBranch;
extern clockRec 		*baseOfClock;
extern nodeRec 			*baseOfNode;
extern nonlinRec 		*baseOfNonlin;
extern digitalRec 		*baseOfDigital;
extern logicRec 		*baseOfLogic;
extern tableRec 		*baseOfTable;
extern modelRec 		*baseOfModel;
extern sourceRec 		*baseOfSource;
extern printRec 		*baseOfPrint;
extern FILE				*print_file;
extern fftRec			*baseOfFFT;
extern fftMRec			*baseOfMFFT;
extern statusRec 		*baseOfStatus;
extern subcktRec 		*baseOfSubckt;
extern double 			*vv_x;
extern double 			*vv_s;
extern double 			*GND;
extern long 			twoTerminal;
extern long 			fourTerminal;
extern long 			nonlinears;
extern long 			globalControl;
extern long 			digitals;
extern long 			logicals;
extern systemRec 		*presentSys;
extern boolean			fft_to_file;
extern aWord			fft_filename;
extern boolean			fft_must_reorder;
extern int				fft_window;
extern boolean			print_to_file;
extern aWord			prn_filename;
extern boolean 			shortPrint;
extern boolean 			timePrint;
extern boolean 			runDiag;
extern long 			binaryArray[BINARY_LEN + 1];
extern nameString 		progName;
#endif
