#ifndef _HIPPOIOXDR_H_
#define _HIPPOIOXDR_H_
/*
 * Prototypes for XDR routines to write hippo structures.
 */

bool_t xdr_floatarray(XDR *xdrs, caddr_t *objp, unsigned int *count,
		      unsigned int max);

bool_t xdr_rectangle(XDR *xdrs, rectangle *objp);

bool_t xdr_func_id_t(XDR *xdrs, func_id_t *objp);

bool_t xdr_func_id(XDR *xdrs, func_id *objp);

bool_t xdr_ntuple_t(XDR *xdrs, ntuple_t *objp);

bool_t xdr_ntuple(XDR *xdrs, ntuple *objp);

bool_t xdr_bins_t(XDR *xdrs, bins_t *objp);

bool_t xdr_axis_t(XDR *xdrs, axis_t *objp);

bool_t xdr_bind_strt_t(XDR *xdrs, bind_strt_t *objp);

bool_t xdr_display_t(XDR *xdrs, display_t *objp);

bool_t xdr_display(XDR *xdrs, display *objp);

bool_t xdr_hippo_rec(XDR *xdrs, hippo_rec *objp);

bool_t xdr_3Dstruct(XDR * xdrs, display_t * objp);

#endif  /* end of _HIPPOIOXDR_H_ */
